Index: src/Potentials/Specifics/PairPotential_Harmonic.hpp
===================================================================
--- src/Potentials/Specifics/PairPotential_Harmonic.hpp	(revision 5b572453f3696dfe64e32fd5b3a3a1e74aef4b3b)
+++ src/Potentials/Specifics/PairPotential_Harmonic.hpp	(revision 9e903b3e7c30cd9a3ff47d2adb5dc8e7b73bee4f)
@@ -27,4 +27,6 @@
 class PairPotential_Harmonic : virtual public EmpiricalPotential, virtual public FunctionModel
 {
+  //!> grant unit test access to internal parts
+  friend class PairPotential_HarmonicTest;
   // some repeated typedefs to avoid ambiguities
   typedef FunctionModel::arguments_t arguments_t;
Index: src/Potentials/Specifics/unittests/Makefile.am
===================================================================
--- src/Potentials/Specifics/unittests/Makefile.am	(revision 9e903b3e7c30cd9a3ff47d2adb5dc8e7b73bee4f)
+++ src/Potentials/Specifics/unittests/Makefile.am	(revision 9e903b3e7c30cd9a3ff47d2adb5dc8e7b73bee4f)
@@ -0,0 +1,29 @@
+# PLEASE adhere to the alphabetical ordering in this Makefile!
+# Also indentation by a single tab
+
+POTENTIALSSPECIFICSTESTSSOURCES = \
+	../Potentials/Specifics/unittests/PairPotential_HarmonicUnitTest.cpp
+
+POTENTIALSSPECIFICSTESTSHEADERS = \
+	../Potentials/Specifics/unittests/PairPotential_HarmonicUnitTest.hpp
+
+POTENTIALSSPECIFICSTESTS = \
+	PairPotential_HarmonicUnitTest
+
+TESTS += $(POTENTIALSSPECIFICSTESTS)
+check_PROGRAMS += $(POTENTIALSSPECIFICSTESTS) 
+noinst_PROGRAMS += $(POTENTIALSSPECIFICSTESTS)
+
+POTENTIALSSPECIFICSLIBS = \
+	../libMolecuilderPotentials.la \
+	${CodePatterns_LIBS} \
+  $(BOOST_SERIALIZATION_LDFLAGS) $(BOOST_SERIALIZATION_LIBS) \
+	$(BOOST_LIB)
+
+PairPotential_HarmonicUnitTest_SOURCES = $(top_srcdir)/src/unittests/UnitTestMain.cpp \
+	../Potentials/Specifics/unittests/PairPotential_HarmonicUnitTest.cpp \
+	../Potentials/Specifics/unittests/PairPotential_HarmonicUnitTest.hpp
+PairPotential_HarmonicUnitTest_LDADD = ${POTENTIALSSPECIFICSLIBS}
+
+
+#AUTOMAKE_OPTIONS = parallel-tests
Index: src/Potentials/Specifics/unittests/PairPotential_HarmonicUnitTest.cpp
===================================================================
--- src/Potentials/Specifics/unittests/PairPotential_HarmonicUnitTest.cpp	(revision 9e903b3e7c30cd9a3ff47d2adb5dc8e7b73bee4f)
+++ src/Potentials/Specifics/unittests/PairPotential_HarmonicUnitTest.cpp	(revision 9e903b3e7c30cd9a3ff47d2adb5dc8e7b73bee4f)
@@ -0,0 +1,152 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2012 University of Bonn. All rights reserved.
+ * 
+ *
+ *   This file is part of MoleCuilder.
+ *
+ *    MoleCuilder is free software: you can redistribute it and/or modify
+ *    it under the terms of the GNU General Public License as published by
+ *    the Free Software Foundation, either version 2 of the License, or
+ *    (at your option) any later version.
+ *
+ *    MoleCuilder is distributed in the hope that it will be useful,
+ *    but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *    GNU General Public License for more details.
+ *
+ *    You should have received a copy of the GNU General Public License
+ *    along with MoleCuilder.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+/*
+ * PairPotential_HarmonicUnitTest.cpp
+ *
+ *  Created on: Oct 04, 2012
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+using namespace std;
+
+#include <cppunit/CompilerOutputter.h>
+#include <cppunit/extensions/TestFactoryRegistry.h>
+#include <cppunit/ui/text/TestRunner.h>
+
+#include "PairPotential_HarmonicUnitTest.hpp"
+
+#include <boost/assign.hpp>
+
+#include "CodePatterns/Assert.hpp"
+
+#include "FunctionApproximation/FunctionArgument.hpp"
+#include "Potentials/Specifics/PairPotential_Harmonic.hpp"
+#include "Potentials/helpers.hpp"
+
+using namespace boost::assign;
+
+#ifdef HAVE_TESTRUNNER
+#include "UnitTestMain.hpp"
+#endif /*HAVE_TESTRUNNER*/
+
+/********************************************** Test classes **************************************/
+
+// Registers the fixture into the 'registry'
+CPPUNIT_TEST_SUITE_REGISTRATION( PairPotential_HarmonicTest );
+
+
+void PairPotential_HarmonicTest::setUp()
+{
+  // failing asserts should be thrown
+  ASSERT_DO(Assert::Throw);
+
+  input += 0., 1., 2., 3., 4., 5., 6., 7., 8., 9.;
+  output +=
+      .5*1.+.1,
+      .5*0.+.1,
+      .5*1.+.1,
+      .5*4.+.1,
+      .5*9.+.1,
+      .5*16.+.1,
+      .5*25.+.1,
+      .5*36.+.1,
+      .5*49.+.1,
+      .5*64.+.1;
+
+  CPPUNIT_ASSERT_EQUAL( input.size(), output.size() );
+}
+
+
+void PairPotential_HarmonicTest::tearDown()
+{
+}
+
+/** UnitTest for operator()
+ */
+void PairPotential_HarmonicTest::operatorTest()
+{
+  PairPotential_Harmonic harmonic(.5,1.,.1);
+  for (size_t index = 0; index < input.size(); ++index) {
+    CPPUNIT_ASSERT(
+        Helpers::isEqual(
+            output[index],
+            harmonic( FunctionModel::arguments_t(1,argument_t(input[index])) )[0]
+        )
+    );
+  }
+}
+
+/** UnitTest for derivative()
+ */
+void PairPotential_HarmonicTest::derivativeTest()
+{
+  PairPotential_Harmonic harmonic(.5,1.,.1);
+  CPPUNIT_ASSERT(
+      Helpers::isEqual(
+          0.,
+          harmonic.derivative(
+              FunctionModel::arguments_t(1,argument_t(1.))
+          )[0]
+      )
+  );
+}
+
+
+/** UnitTest for parameter_derivative()
+ */
+void PairPotential_HarmonicTest::parameter_derivativeTest()
+{
+  PairPotential_Harmonic harmonic(.5,1.,.1);
+  CPPUNIT_ASSERT(
+      Helpers::isEqual(
+          0.,
+          harmonic.parameter_derivative(
+              FunctionModel::arguments_t(1,argument_t(1.)),
+              0
+          )[0]
+      )
+  );
+  CPPUNIT_ASSERT(
+      Helpers::isEqual(
+          0.,
+          harmonic.parameter_derivative(
+              FunctionModel::arguments_t(1,argument_t(1.)),
+              1
+          )[0]
+      )
+  );
+  CPPUNIT_ASSERT(
+      Helpers::isEqual(
+          1.,
+          harmonic.parameter_derivative(
+              FunctionModel::arguments_t(1,argument_t(1.)),
+              2
+          )[0]
+      )
+  );
+}
Index: src/Potentials/Specifics/unittests/PairPotential_HarmonicUnitTest.hpp
===================================================================
--- src/Potentials/Specifics/unittests/PairPotential_HarmonicUnitTest.hpp	(revision 9e903b3e7c30cd9a3ff47d2adb5dc8e7b73bee4f)
+++ src/Potentials/Specifics/unittests/PairPotential_HarmonicUnitTest.hpp	(revision 9e903b3e7c30cd9a3ff47d2adb5dc8e7b73bee4f)
@@ -0,0 +1,44 @@
+/*
+ * PairPotential_HarmonicUnitTest.hpp
+ *
+ *  Created on: Oct 04, 2012
+ *      Author: heber
+ */
+
+#ifndef PAIRPOTENTIAL_HARMONICUNITTEST_HPP_
+#define PAIRPOTENTIAL_HARMONICUNITTEST_HPP_
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+
+#include <cppunit/extensions/HelperMacros.h>
+
+class PairPotential_Harmonic;
+
+/********************************************** Test classes **************************************/
+
+class PairPotential_HarmonicTest : public CppUnit::TestFixture
+{
+    CPPUNIT_TEST_SUITE( PairPotential_HarmonicTest) ;
+    CPPUNIT_TEST ( operatorTest );
+    CPPUNIT_TEST ( derivativeTest );
+    CPPUNIT_TEST ( parameter_derivativeTest );
+    CPPUNIT_TEST_SUITE_END();
+
+public:
+      void setUp();
+      void tearDown();
+      void operatorTest();
+      void derivativeTest();
+      void parameter_derivativeTest();
+
+private:
+      typedef std::vector<double> data_t;
+      data_t input;
+      data_t output;
+};
+
+#endif /* PAIRPOTENTIAL_HARMONICUNITTEST_HPP_ */
